﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.EvolutionTracking;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.TravelingSalesman.Analyzers {
  [StorableClass]
  [Item("TSPGenealogyAnalyzer", "A genealogy analyzer for permutation encodings.")]
  public class TSPGenealogyAnalyzer : GenealogyAnalyzer<Permutation> {
    public TSPGenealogyAnalyzer() { }

    [StorableConstructor]
    protected TSPGenealogyAnalyzer(bool deserializing) : base(deserializing) { }

    public TSPGenealogyAnalyzer(TSPGenealogyAnalyzer original, Cloner cloner) : base(original, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new TSPGenealogyAnalyzer(this, cloner);
    }

    protected override void EvaluateIntermediateChildren() {
      throw new System.NotImplementedException();
    }
  }
}
